﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;
using System.Collections;

namespace WindowsFormsApplication9
{
    public partial class Form1 : Form
    {
        //一次处理的数据量
        const int BUFFERLENGTH = 512;
        //每一个 SECTOR 大小
        const int ONESECTOR = 512;
        String Filename="";

        public Form1()
        {
            InitializeComponent();
        }
        private void file2h(String filename)
        {
            byte[] buffer = new byte[BUFFERLENGTH];
            string Contains = "";
            int counter = 0;
            ArrayList SectorIndex = new ArrayList();//声明

            System.IO.FileStream fs = new System.IO.FileStream(filename, System.IO.FileMode.Open);
            System.IO.BinaryReader br = new System.IO.BinaryReader(fs, Encoding.Default);

            while (br.PeekChar() != -1)
            {
                    // 读取BUFFERLENGTH 长度的内容到 Buffer 中 
                    br.Read(buffer, 0, BUFFERLENGTH);
                    for (int i = 0; i < ONESECTOR; i++)
                    {
                        // 如果发现一个字节不为0，那么就保存下来
                        if (buffer[i] != 0)
                        {
                            Contains= Contains+"{\r\n//No. " + counter.ToString() + " Sector: 0x" + ((fs.Position / BUFFERLENGTH - 1)).ToString("x") + "\r\n";
                            for (int k = 0; k < 512; k++)
                            {
                                Contains = Contains + "0x" + buffer[k].ToString("X2") + ",";
                                if (((k + 1) % 16 == 0))
                                {
                                    Contains = Contains + "\r\n";
                                }
                            }
                            Contains = Contains + "},\r\n";
                            counter++;
                            textBox1.AppendText(Contains);
                            Contains = "";

                            SectorIndex.Add((int)((fs.Position / BUFFERLENGTH - 1)));
                            // 继续检查下一个SECTOR
                            break;
                        }
                    }
            }
            br.Close();

            string newLine = "const unsigned char Sector[" + (counter + 1).ToString() + "][512]  = {\r\n"+ textBox1.Text;
            textBox1.Text = newLine;

            Contains = "}; \r\n int Index["+SectorIndex.Count.ToString()+"]= {";
            int Changeline = 0;
            foreach (int Index in SectorIndex)
            {
                Contains = Contains + "0x" + Index.ToString("X") + ",";
                if (Changeline == 16)
                {
                    Contains = Contains + "\r\n";
                    Changeline = 0;
                }
                else { Changeline++; }
            }

            textBox1.AppendText(Contains+"};");


            label1.Text = "Size: "+(counter* BUFFERLENGTH).ToString()+"bytes";
        }
        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog openfiledialog = new OpenFileDialog();//声明并初始化openfiledialog类
            openfiledialog.InitialDirectory = @"c:\";//设置文件打开初始目录为E盘
            openfiledialog.Title = "Open binary file";//设置打开文件对话框标题
            openfiledialog.Filter = "All Files(*.*)|*.*|Bin Files(*.bin)|*.bin";//设置文件过滤类型
            openfiledialog.FilterIndex = 1;//根据文件类型索引设置文件过滤类型
            openfiledialog.RestoreDirectory = true;//设置对话框是否记忆之前打开的目录
            if (openfiledialog.ShowDialog() == DialogResult.OK)//当点击文件对话框的确定按钮时打开相应的文件
            {                                                  //并执行如下语句块
               // tbfilepath.Text = openfiledialog.FileName;//获取选择文件的完整路径名（含文件名称）
               // tbfilename.Text = tbfilepath.Text.Substring(tbfilepath.Text.LastIndexOf("\\") + 1);
                file2h(openfiledialog.FileName);
                Filename = openfiledialog.FileName;
            }                                             //获取选择文件的完整文件名（不含路径）
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (Filename!="") {
                System.IO.File.WriteAllText(Filename+".h", textBox1.Text);
                MessageBox.Show(Filename + ".h"+" is generated!");
            }
        }
    }
}
